#include	<unistd.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<time.h>
#include	<sys/time.h>
#include	<sys/file.h>
#if linux
#include	<linux/termios.h>
#endif
#include	<signal.h>

	/*
	** X things
	*/
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/cursorfont.h>
#include <X11/Shell.h>
#include <X11/Xaw/Paned.h>
#include <X11/Xaw/List.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Cardinals.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/SmeBSB.h>


Display		*display;
Window          graphics_window;
Widget		graphics_widget;
Widget		top;
Widget          filepopupbutton;
struct tm       *start_tm;
int		centre_frequency;
int		duration;
int		reverse;
float		diameter;

XEvent		event;
GC		graphics_gc;
GC		clobber_gc;

#define INV_PAINT       0
#define MERGE           1
#define PAINT           2
#define ERASE           3

int		debug;
char		*progname;

/* function protos */
void		ferr(char *f, ...);
void		warn(char *f, ...);
void		DoQuit();
void		DoPattern();
void		DrawTarget();
void		DoTest();
Widget		info_text;
void		initfonts();
void		PopupPrompt(Widget button, XtPointer client_data, 
			XtPointer call_data);
Widget		MakeFilePopup(Widget box);
Widget		MakeCommandButton(Widget box, char *name, XtCallbackProc function);
void		makeButtonsAndBoxes(Widget parent);
void		InfoPrintf(char *str);
void		PopDownCB(Widget w, XtPointer client_data);
void		ErrorPopup(Widget caller, char *errormessage);
void		PersonPopup(Widget caller);
void		OpenTmpFile();
FILE		*yyyy;
FILE		*infp;
FILE		*replayfp;
FILE		*xxxx;
void 		WriteHeaders(FILE *outfp, char *name);
void 		ReadHeaders(FILE *replayfp, char *name);
FILE		*tmpfp;

int		replaying;
int		replaypos,
		replayfont;
char		replaychar,
		replayans;

#define MYBLACK (reverse ?  WhitePixel(display,DefaultScreen(display)) : \
		BlackPixel(display,DefaultScreen(display)))
#define MYWHITE (reverse ?  BlackPixel(display,DefaultScreen(display)) : \
		WhitePixel(display,DefaultScreen(display)))


/* test data stuff */
#define	TESTS_READ	0
#define TESTS_WRITE	1
#define MAXTESTS	2000
#if linux
#define MAXFONTSIZES	10
#else
#define MAXFONTSIZES	9
#endif
char	*person;
#define RIGHTEYE 1
#define LEFTEYE 2
#define BOTHEYES 3
#define WINMID (WINWIDTH/2)
int	eye;
char	eyename[20];
char	distname[20];
#define VERYLONGDISTNAME	"114cm"
#define LONGDISTNAME	"57cm"
#define SHORTDISTNAME	"28.5cm"
float	start_point_size;
float	point_size[MAXFONTSIZES];
int	testpos[MAXFONTSIZES][MAXTESTS];
char	testchar[MAXFONTSIZES][MAXTESTS];
char	testans[MAXFONTSIZES][MAXTESTS];
int	ntests[MAXFONTSIZES];
Font	fontID[MAXFONTSIZES];
int	maxfontsizes;
int	fontsready;
int	nfont;
int	testnum;
int	StartedButNotSaved;
int	required_changes;

/*
**	Position settings/stats
**
**		    6
**		    2
**		7 3 0 1 5
**		    4
**		    8
*/
#define NPOSITIONS	9
#define	CHANGES		6

int	seqnum[NPOSITIONS];

#define BLIND_CRITERION	6

#define	FLAG_BLIND	01
#define FLAG_BELOW_DONE	02
#define FLAG_FINISHED	04

struct	position
{
	int		nfont;
	int		anyerror;	/* added in 0.25 */
	int		flag;
	int		done;		/* set when the pointsize has become too small */
	int		nconsec;
	int		lastresult[BLIND_CRITERION];
	int		ntests[MAXFONTSIZES];
	int		ncorrect[MAXFONTSIZES];
	char		testchar[MAXFONTSIZES][MAXTESTS];
	float		testsize[MAXFONTSIZES][MAXTESTS];
	char		testans[MAXFONTSIZES][MAXTESTS];
	int		testnum[MAXFONTSIZES][MAXTESTS];
	int		seqnum[MAXFONTSIZES][MAXTESTS];
	int		x;
	int		y;
	int		nchanges;
}
position[NPOSITIONS];
