#include "defs.h"
#include "font.h"
#include "screen.h"
#include <math.h>

void
setfonts(int n)
{
	XSetFont (display, graphics_gc, fontID[n]);
	XSetFont (display, clobber_gc, fontID[n]);
}

void initfonts()
{
	float	psize;
	int i;
	fprintf(stderr,"INITFONTS CALLED\n");
	if(diameter == 0 || replaying)
	{
		if(distname[0] == '\0')
		{
			diameter = DIAMETER;
			warn("diameter set to %f (default)", diameter);
			if(start_point_size == 0)
			{
				start_point_size = POINTSIZE;
				warn("starting point size from default = %f",
					start_point_size);
			}
		}
		else if(strcmp(distname, SHORTDISTNAME) == 0)
		{
			diameter = DIAMETER/2;
			warn("diameter set for distance %s now %f",
				distname, diameter);
			if(start_point_size == 0)
			{
				start_point_size = POINTSIZE/2;
				warn("starting point size set to %f",
					start_point_size);
			}
		}
		else if(strcmp(distname, LONGDISTNAME) == 0)
		{
			diameter = DIAMETER;
			warn("diameter set for distance %s now %f",
				distname, diameter);
			if(start_point_size == 0)
			{
				start_point_size = POINTSIZE;
				warn("starting point size set to %f",
					start_point_size);
			}
		}
		else if(strcmp(distname, VERYLONGDISTNAME) == 0)
		{
			diameter = DIAMETER*2;
			warn("diameter set for distance %s now %f",
				distname, diameter);
			if(start_point_size == 0)
			{
				start_point_size = POINTSIZE*2;
				warn("starting point size set to %f",
					start_point_size);
			}
		}
		else
			ferr("cannot match distname %s", distname);
	}

	point_size[0] = start_point_size;
	for( i=0; i<MAXFONTSIZES; i++)
	{
		psize = POINTSIZE;
		if(debug)
			fprintf(stderr,"point_size[%d] = %f\n",
				i, point_size[i]);
		if((fontinfo[i] = XLoadQueryFont(display,
			fontname((int)(point_size[i] * 10)))) == NULL)
		{
			warn("cannot load font %s",  fontname((int)(point_size[i] * 10)));
			warn("limited to %d font sizes");
			break;
		}
		fontID[i] = fontinfo[i]->fid;
		point_size[i+1] = point_size[i]/sqrt(2.);
		maxfontsizes = i + 1;
	}
	setfonts(0);
	fontsready = 1;
}

char	*fontname(int pointsize)
{
	static char name[BUFSIZ];

#if linux
	sprintf(name, "-*-helvetica-bold-r-*-*-*-%d-*-*-*-*-*-*", pointsize);
#else
	sprintf(name, "-*-helvetica-bold-r-*--*-%d-*-*-*-*-*-*", pointsize);
#endif
	if(debug)
		warn("font: %s\n", name);
	return(name);
}

