#include	"defs.h"
#include	"fileio.h"
#include	<time.h>
#include	<sys/types.h>
#include	<sys/stat.h>
#include	<sys/param.h>
#include	<sys/dir.h>
#include	<pwd.h>

extern char	*version;

void ListReadCB(Widget w, XtPointer client_data);
void WritePopup(Widget button, XtPointer client_data, XtPointer call_data);
void ReadPopup(Widget button, XtPointer client_data, XtPointer call_data);
void DoRead(Widget w, char *name);
int  DoWrite(Widget w, char *name);
void Write(Widget widget, XEvent *event, String *params, Cardinal *num_params);
void DestroyPopupPrompt(Widget widget, XtPointer client_data, XtPointer call_data);
void StoreName(Widget widget, XtPointer client_data);
void SetLeft();
void SetRight();
void SetBoth();
void eyepick(Widget w, XtPointer c, XtPointer call_data);
void distpick(Widget w, XtPointer c, XtPointer call_data);
Widget MakeEyePopup(Widget box);

Widget MakeFilePopup(Widget box)
{
	Widget	button,
		readitem,
		writeitem,
		quititem,
		patternitem,
		filemenushell;

	button = XtCreateManagedWidget
        (
                "File",
		menuButtonWidgetClass,
		box,
		NULL,
		ZERO
	);
	filemenushell = XtCreatePopupShell("menu", simpleMenuWidgetClass,
		button, NULL, ZERO);
	writeitem = XtCreateManagedWidget("write", smeBSBObjectClass,
		filemenushell, NULL, ZERO);
	XtAddCallback(writeitem, XtNcallback, WritePopup, NULL);
	readitem = XtCreateManagedWidget("read", smeBSBObjectClass,
		filemenushell, NULL, ZERO);
	XtAddCallback(readitem, XtNcallback, ReadPopup, NULL);
	quititem = XtCreateManagedWidget("quit", smeBSBObjectClass,
		filemenushell, NULL, ZERO);
	XtAddCallback(quititem, XtNcallback, DoQuit, 0);
	patternitem = XtCreateManagedWidget("test", smeBSBObjectClass,
		filemenushell, NULL, ZERO);
	XtAddCallback(patternitem, XtNcallback, DoPattern, 0);

	return(button);
}

void 
ReadPopup(Widget button, XtPointer client_data, XtPointer call_data)
{
	Arg		args[5];
	Widget		popup;
	Position	x, y;
	Dimension	width, height;
	Cardinal	n;
	Widget		ReadDialog;

	n = 0;
	XtSetArg(args[0], XtNwidth, &width);
	n++;
	XtSetArg(args[1], XtNheight, &height);
	n++;
	XtGetValues(button, args, n);
	XtTranslateCoords(button, (Position) (width / 2), (Position) (height / 2),
		      &x, &y);

	n = 0;
	XtSetArg(args[n], XtNx, x);	
	n++;
	XtSetArg(args[n], XtNy, y);	
	n++;

	popup = XtCreatePopupShell("File Read", transientShellWidgetClass, top,
			       args, n);

	/* 
	* The popup will contain a dialog box, prompting the user for input. 
	*/

	ReadDialog = XtCreateManagedWidget("ReadDialog", dialogWidgetClass, popup,args, n);

	/*
	* The prompting message's size is dynamic; allow it to request resize. 
	*/

	XawDialogAddButton(ReadDialog, "Cancel", DestroyPopupPrompt,(XtPointer)ReadDialog);

	XtPopup(popup, XtGrabNone);
}

void 
WritePopup(Widget button, XtPointer client_data, XtPointer call_data)
{
	Arg		args[5];
	Widget		popup;
	Position	x, y;
	Dimension	width, height;
	Cardinal	n;
	Widget		WriteDialog;
	char		filename[MAXPATHLEN];
	int		minutes;

	/* this will position the widget */
	n = 0;
	XtSetArg(args[0], XtNwidth, &width);
	n++;
	XtSetArg(args[1], XtNheight, &height);
	n++;
	XtGetValues(button, args, n);
	XtTranslateCoords(button, (Position) (width/2), (Position) (height/2),
		      &x, &y);

	n = 0;
	XtSetArg(args[n], XtNx, x);	
	n++;
	XtSetArg(args[n], XtNy, y);	
	n++;

	popup = XtCreatePopupShell("File Write", transientShellWidgetClass, top,
			       args, n);

	/* 
	* The popup will contain a dialog box, prompting the user for input. 
	*/

	n=0;

	minutes = start_tm->tm_min + (start_tm->tm_sec + 30)/60 +1;
	sprintf(filename, "%04d%02d%02d.%02d%02d",
		start_tm->tm_year +1900,
		start_tm->tm_mon+1,
		start_tm->tm_mday,
		start_tm->tm_hour,
		minutes);
	XtSetArg(args[n], "value", filename);
	n++;
	WriteDialog = XtCreateManagedWidget
		("WriteDialog", dialogWidgetClass, popup,args, n);

    /*
     * The prompting message's size is dynamic; allow it to request resize. 
     */

    XawDialogAddButton(WriteDialog, "Write", (XtCallbackProc)Write, (XtPointer) WriteDialog);
    XawDialogAddButton(WriteDialog, "Cancel", DestroyPopupPrompt,(XtPointer)WriteDialog);

    XtPopup(popup, XtGrabNone);
}

void
PopDownCB(Widget w, XtPointer client_data)
{
	Widget shell = (Widget)client_data;
	XtPopdown(shell);
}

void
ListReadCB(Widget w, XtPointer client_data)
{
	XawListReturnStruct *data;
	fprintf(stderr,"in ListReadCB\n");
	data = XawListShowCurrent(w);
	/* data = (_XawListReturnStruct *) client_data; */
	fprintf(stderr,"data set\n");
	fprintf(stderr,"data->list_index = %d\n", data->list_index);
	DoRead(w, data->string);
}

void 
ErrorPopup(Widget caller, char *errormessage)
{
	Cardinal	n;
	Arg		args[5];
	Widget		popup;
	Widget		labelW;
	Widget		cancelbutton;
	Widget		form;
	Position	x, y;
	Dimension	width, height;

	/* this will position the widget */
	n = 0;
	XtSetArg(args[0], XtNwidth, &width);
	n++;
	XtSetArg(args[1], XtNheight, &height);
	n++;
	XtGetValues(caller, args, n);
	XtTranslateCoords(caller, (Position) (width/10), (Position) (height/10),
		      &x, &y);

	n = 0;
	XtSetArg(args[n], XtNx, x);	
	n++;
	XtSetArg(args[n], XtNy, y);	
	n++;

	popup = XtVaCreatePopupShell("Error", transientShellWidgetClass,
		top,
			XtNallowShellResize,	True,
			XtNx,			x,
			XtNy,			y,
			NULL);

	form = XtVaCreateManagedWidget
			("errorform", formWidgetClass, popup, NULL);
	if(debug)
		fprintf(stderr,"passing <%s> to errortext widget\n",
			errormessage);
	labelW = XtVaCreateManagedWidget(
		"label", labelWidgetClass,
		form,
		XtNlabel,    errormessage,
		NULL);

	cancelbutton = XtVaCreateManagedWidget("cancel", commandWidgetClass,
				form,
				XtNfromVert, labelW,
				XtNtop,      XawChainTop,
				XtNbottom,   XawChainTop,
				XtNleft,     XawChainLeft,
				XtNright,    XawChainLeft,
				XtNlabel,    "Acknowledge",
				NULL);
	XtAddCallback(cancelbutton, XtNcallback,
		(XtCallbackProc)PopDownCB, (XtPointer)popup);
	XtPopup(popup, XtGrabExclusive);
}

void
DoRead(Widget w, char *name)
{
	char	mess[BUFSIZ];

	if((infp = fopen(name,"r")) == NULL)
	{
		sprintf(mess, "Could not open: %s", name);
		ErrorPopup(w, mess);
		warn("cannot open: %s", name);
		return;
	}
	sprintf(mess, "no read code: %s", name);
	ErrorPopup(w, mess);
}

void
DestroyPopupPrompt(Widget widget, XtPointer client_data, XtPointer call_data)
{
    Widget popup = XtParent( (Widget) client_data);
    XtDestroyWidget(popup);
}

void 
FileIO(Widget w, int flag, XtPointer client_data, XtPointer call_data)
{
	Widget dialog = (Widget) client_data;
	String cname = XawDialogGetValueString(dialog);

	if(strlen(cname) >0) switch(flag)
	{
		case TESTS_WRITE:
			if(DoWrite(w, cname))
				return;
			DestroyPopupPrompt(NULL, (XtPointer) dialog, (XtPointer)NULL);
			break;
	}
}

int
DoWrite(Widget w, char *name)
{
	int		i;
	int		n;
	int		t;
	FILE		*outfp;
	char		mess[BUFSIZ];

	if((outfp = fopen(name,"w")) == NULL)
	{
		sprintf(mess, "Could not open for writing: %s", name);
		ErrorPopup(w, mess);
		warn("cannot open for writing: %s", name);
		return(1);
	}
	
	WriteHeaders(outfp, name);
	for(n = 0; n <= 8; n++)
	{
		fprintf(outfp, "Position: %d\n", n);
		for(i = 0; i < maxfontsizes; i++)
		{
			fprintf(outfp, "Pointsize: %f\n", point_size[i]);
			for(t = 0; t < position[n].ntests[i]; t++)
			{
				fprintf(outfp,"%c	%c	%d	%d\n",
					position[n].testchar[i][t],
					position[n].testans[i][t],
					position[n].seqnum[i][t],
					position[n].testnum[i][t]
					);
			}
		}
	}
	fclose(outfp);
	return(0);
}

char		origfilename[BUFSIZ];
char		origversion[BUFSIZ];
char		origuser[BUFSIZ];
char		origperson[BUFSIZ];
char		orighost[BUFSIZ];
char		origdisplay[BUFSIZ];

void ReadHeaders(FILE *fp, char *name)
{
	char		fg[BUFSIZ];
	char		bg[BUFSIZ];
	char		line[BUFSIZ];
	char		*p;

	while(fgets(line, BUFSIZ, fp) != NULL)
	{
		if(strcmp(line, ENDTAGSTAG) == 0)
			return;
		if((p = strchr(line, '\n')) == NULL)
			ferr("unterminated line in %s:\n\t%s", name, line);
		*p = '\0';
		if((p = strchr(line, ':')) == NULL)
			ferr("untagged line in %s:\n\t%s", name, line);
		*p = '\0';
		p += 2;		/* now points at value */
		if(strcmp(line, FILETAG) == 0)
			strcpy(origfilename, p);
		else if(strcmp(line, VERSIONTAG) == 0)
			strcpy(origversion, p);
		else if(strcmp(line, USERTAG) == 0)
			strcpy(origuser, p);
		else if(strcmp(line, SUBJECTTAG) == 0)
		{
			strcpy(origperson, p);
			person = origperson;
		}
		else if(strcmp(line, EYETAG) == 0)
			strcpy(eyename, p);
		else if(strcmp(line, WORKDISTTAG) == 0)
			strcpy(distname, p);
		else if(strcmp(line, HOSTTAG) == 0)
			strcpy(orighost, p);
		else if(strcmp(line, DISPLAYTAG) == 0)
			strcpy(origdisplay, p);
		else if(strcmp(line, DIAMETERTAG) == 0)
			diameter = atof(p);
		else if(strcmp(line, CENTREFREQUENCYTAG) == 0)
			centre_frequency = atoi(p);
		else if(strcmp(line, FOREGROUNDTAG) == 0)
			strcpy(fg, p);
		else if(strcmp(line, BACKGROUNDTAG) == 0)
			strcpy(bg, p);
		else if(strcmp(line, SIZECHANGESTAG) == 0)
			required_changes = atoi(p);
	}
	ferr("unexpected EOF reading %s", name);
}

void WriteHeaders(FILE *outfp, char *name)
{
	struct passwd	*pw;
	char		host[BUFSIZ];

	pw = getpwuid(getuid());

	if(replaying)
		fprintf(outfp, "%s: %s\nReplay-", FILETAG, origfilename),
	fprintf(outfp, "%s: %s\n", FILETAG, name);
	if(replaying)
		fprintf(outfp, "%s: %s\nReplay-", VERSIONTAG, origversion),
	fprintf(outfp, "%s: %s\n", VERSIONTAG, version);
	if(replaying)
		fprintf(outfp, "%s: %s\nReplay-", USERTAG, origuser),
	fprintf(outfp, "%s: %s\n", USERTAG, pw->pw_name);
	fprintf(outfp, "%s: %s\n", SUBJECTTAG, person);
	fprintf(outfp, "%s: %s\n", EYETAG, eyename);
	fprintf(outfp, "%s: %s\n", WORKDISTTAG, distname);
	if(replaying)
		fprintf(outfp, "%s: %s\nReplay-", HOSTTAG, orighost);
	if(gethostname(host, BUFSIZ))
		strcpy(host, "unknown");
	fprintf(outfp, "%s: %s\n", HOSTTAG, host);
	if(replaying)
		fprintf(outfp, "%s: %s\nReplay-", DISPLAYTAG, origdisplay),
	fprintf(outfp, "%s: %s\n", DISPLAYTAG, getenv("DISPLAY"));
	fprintf(outfp, "%s: %f\n", DIAMETERTAG, diameter);
	fprintf(outfp, "%s: %d\n", CENTREFREQUENCYTAG, centre_frequency);
	fprintf(outfp, "%s: %s\n", FOREGROUNDTAG, reverse? "white" : "black");
	fprintf(outfp, "%s: %s\n", BACKGROUNDTAG, reverse? "black" : "white");
	fprintf(outfp, "%s: %d\n", SIZECHANGESTAG, required_changes);
	fprintf(outfp, "%s", ENDTAGSTAG);	/* \n in defined string */
}

void Write(Widget widget, XEvent *event, String *params, Cardinal *num_params)
{
	Widget dialog = XtParent(widget);

	if(debug)
		fprintf(stderr,"Write() called\n");
	FileIO(widget, TESTS_WRITE, (XtPointer) dialog, (XtPointer) NULL);
	StartedButNotSaved = 0;
}

void 
PersonPopup(Widget caller)
{
	Cardinal	n;
	Arg		args[5];
	Widget		popup;
	Widget		eyelist;
	Widget		distlist;
	Widget		cancelbutton;
	Widget		acceptbutton;
	Widget		form;
	Position	x, y;
	static String	eyenames[2] = { "left", "right"};
	static String	distnames[3] = { VERYLONGDISTNAME, LONGDISTNAME, SHORTDISTNAME};
	Position	xparent, yparent;
	Dimension	width, height;
	Widget		NameDialog;


	/* this will position the widget */
	n = 0;
	XtSetArg(args[0], XtNwidth, &width);
	n++;
	XtSetArg(args[1], XtNheight, &height);
	n++;
	XtSetArg(args[n], XtNx, &xparent);
	n++;
	XtSetArg(args[n], XtNy, &yparent);
	n++;
	XtGetValues(graphics_widget, args, n);
	
	XtTranslateCoords(caller, (Position) (width/2), (Position) (height/2),
		      &x, &y);

	n = 0;
	XtSetArg(args[n], XtNx, x);	
	n++;
	XtSetArg(args[n], XtNy, y);	
	n++;

	popup = XtVaCreatePopupShell("Personal Data", transientShellWidgetClass,
		top,
			XtNallowShellResize,	True,
			NULL);

	form = XtVaCreateManagedWidget
			("personform", formWidgetClass, popup, NULL);

	/* 
	 * The popup will contain a dialog box, prompting user for their name
	 */

	NameDialog = XtCreateManagedWidget("NameDialog", dialogWidgetClass, form ,args, n);

	eyelist = XtVaCreateManagedWidget("eyelist", listWidgetClass, form,
				XtNfromVert, NameDialog,
				XtNleft,     XawChainLeft,
				XtNheight,	100,
				NULL);
	XawListChange(eyelist, eyenames, 2, 0, True);
	XtAddCallback(eyelist, XtNcallback, eyepick, (XtPointer)NULL);
	distlist = XtVaCreateManagedWidget("distlist", listWidgetClass, form,
				XtNfromVert, eyelist,
				XtNleft,     XawChainRight,
				XtNheight,	100,
				NULL);
	XawListChange(distlist, distnames, 3, 0, True);
	XtAddCallback(distlist, XtNcallback, distpick, (XtPointer)NULL);
	acceptbutton = XtVaCreateManagedWidget("accept", commandWidgetClass,
				form,
				XtNfromVert, distlist,
				XtNtop,      XawChainTop,
				XtNbottom,   XawChainTop,
				XtNleft,     XawChainLeft,
				XtNright,    XawChainLeft,
				XtNlabel,    "Accept",
				NULL);
	XtAddCallback(acceptbutton, XtNcallback,
		(XtCallbackProc)StoreName, (XtPointer)NameDialog);

	cancelbutton = XtVaCreateManagedWidget("cancel", commandWidgetClass,
				form,
				XtNfromHoriz, acceptbutton,
				XtNbottom,   XawChainBottom,
				XtNfromVert, distlist,
				XtNlabel,    "Cancel",
				NULL);
	XtAddCallback(cancelbutton, XtNcallback,
		(XtCallbackProc)PopDownCB, (XtPointer)popup);
	XtPopup(popup, XtGrabExclusive);
}

void OpenTmpFile()
{
#if ultrix || __alpha
	static	char	tmpStorage[L_tmpnam];
	static  char	*tmpfile = tmpStorage;
#else
	static	char	tmpfile[] = "/tmp/xactmpXXXXXX";
	int		fd;
#endif

#if ultrix || __alpha
	tmpfile = tempnam("/tmp","xac");
	if((tmpfp = fopen(tmpfile,"w")) == NULL)
		warn("cannot create log temp file %s", tmpfile);
#else
#if DANGEROUS
	(void) mktemp(tmpfile);
#else
	if((fd = mkstemp(tmpfile)) < 0)
		ferr("cannot create temp log file");
	if((tmpfp = fdopen(fd,"w")) == NULL)
		ferr("cannot fdopen temp log file %s", tmpfile);
#endif
#endif
	fprintf(stderr, "raw data being written to %s\n", tmpfile);
	WriteHeaders(tmpfp, tmpfile);
	fflush(tmpfp);
}

void StoreName(Widget widget, XtPointer client_data)
{
	String name = XawDialogGetValueString(client_data);

	person = XtNewString(name);
	XtDestroyWidget(XtParent(XtParent(widget)));
	InfoPrintf("Press start to commence test");
}

void SetLeft()
{
	eye = LEFTEYE;
	fprintf(stderr,"reached SetLeft\n");
}

void SetRight()
{
	eye = RIGHTEYE;
	fprintf(stderr,"reached SetRight\n");
}

void SetBoth()
{
	eye = BOTHEYES;
	fprintf(stderr,"reached SetBoth\n");
}

Widget MakeEyePopup(Widget box)
{
	Widget		eyemenushell;
	Widget		eyebutton;
	Widget		leftitem;
	Widget		rightitem;
	Widget		bothitem;

	eyebutton = XtVaCreateManagedWidget
        (
                "Eye",
		menuButtonWidgetClass,
		box,
		NULL
	);
	eyemenushell = XtCreatePopupShell("menu", simpleMenuWidgetClass,
				eyebutton, NULL, 0);
	leftitem = XtCreateManagedWidget("left", smeBSBObjectClass,
		eyemenushell, NULL, ZERO);
	XtAddCallback(leftitem, XtNcallback, SetLeft, NULL);
	rightitem = XtCreateManagedWidget("right", smeBSBObjectClass,
		eyemenushell, NULL, ZERO);
	XtAddCallback(rightitem, XtNcallback, SetRight, NULL);

	bothitem = XtCreateManagedWidget("both", smeBSBObjectClass,
		eyemenushell, NULL, ZERO);
	XtAddCallback(bothitem, XtNcallback, SetBoth, NULL);
	return(eyebutton);
}

void eyepick(Widget w, XtPointer c, XtPointer call_data)
{
	XawListReturnStruct *item = (XawListReturnStruct*)call_data;
	strcpy(eyename, item->string);
}

void distpick(Widget w, XtPointer c, XtPointer call_data)
{
	XawListReturnStruct *item = (XawListReturnStruct*)call_data;
	strcpy(distname, item->string);
}
