#include "defs.h"

GC
makegc(int op, Pixel fg, Pixel bg)
{
	register GC     ngc,
			tgc;
	XGCValues       gcv;
	unsigned long   gcmask;
	XFontStruct	*info;

	tgc = DefaultGC(display, DefaultScreen(display));
	if((info = XLoadQueryFont(display, "6x10")) == NULL)
		ferr("cannot get font info");

	gcv.font = info->fid;
	gcv.join_style = JoinMiter;
	gcv.line_width = 10;
	gcv.line_style = LineSolid;
	gcv.fill_style = FillSolid;
	gcmask = GCJoinStyle | GCFunction | GCForeground | GCBackground | GCFont;
	switch (op) {
	case PAINT:
		gcv.foreground = fg;
		gcv.background = bg;
		gcv.function = GXcopy;
		break;
	case ERASE:
		gcv.foreground = bg;
		gcv.background = bg;
		gcv.function = GXcopy;
		break;
	case INV_PAINT:
		gcv.foreground = fg ^ bg;
		gcv.background = bg;
		gcv.function = GXxor;
		break;
	case MERGE:
		gcv.foreground = fg;
		gcv.background = bg;
		gcv.function = GXor;
		break;
	}

	ngc = XCreateGC(display, graphics_window, gcmask, &gcv);
	XCopyGC(display, tgc, ~(gcmask), ngc);
	return (ngc);
}
